/*
 * Copyright 2013 Cloudera Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.solr.client.solrj.retry;

/** Holder for a mutable long integer value */
final class MutableLong {

  private long value;

  public MutableLong(long value) {
    this.value = value;
  }

  public long get() {
    return value;
  }

  public void inc(long value) {
    this.value += value;
  }

  @Override
  public String toString() {
    return String.valueOf(value);
  }

}
